﻿function effaceFond()
{
	ctFond.clearRect (0,0,lCanv,hCanv);
}

function fondBlanc()
{
	effaceFond();
	ctFond.fillStyle="white";
	ctFond.fillRect (0,0,lCanv,hCanv);
	var coul=0;
	var x0;
	var x1;
	var x2;
	var r=0;
	var opa=0;
	var angle=0;
	var d=lCanv;
	for (var i=0;i<d;i++)
	{// bandes horizontales
		ctFond.beginPath();
		c=255-Math.round(Math.random()*200);
		coul="rgba("+c+","+c+","+c+",0.8)";
		y1=Math.random()*hCanv;
		y2=Math.random()*hCanv;
		ctFond.lineWidth=Math.random()*10;
		ctFond.strokeStyle=coul;
		ctFond.moveTo(0,y1);
		ctFond.lineTo(lCanv,y2);
		ctFond.stroke();
	}
	
	for (var i=0;i<d;i++)
	{// bandes verticales
		ctFond.beginPath();
		c=255-Math.round(Math.random()*200);
		c2=Math.round(c*0.85);
		if (c<0) {c=0;}
		coul="rgba("+c+","+c+","+c2+",0.15)";
		x0=Math.random()*lCanv;
		x1=x0+Math.random()*100-50;
		x2=x0+Math.random()*100-50;
		ctFond.lineWidth=Math.random()*50;
		ctFond.strokeStyle=coul;
		ctFond.moveTo(x1,0);
		ctFond.lineTo(x2,hCanv);
		ctFond.stroke();
	}
	
	for (var i=0;i<d*3;i++)
	{
		y1=Math.random()*hCanv;
		x1=Math.random()*lCanv;
		c=255-Math.round(Math.random()*10);
		opa=Math.round(Math.random()*6)/10+0.3;
		c2=Math.round(c*0.85);
		coul="rgba("+c+","+c+","+c2+","+opa+")";
		ctFond.fillStyle=coul;
		ctFond.fillRect (x1,y1,1,2);
	}
	
	for (var i=0;i<d*5;i++)
	{
		y1=Math.random()*hCanv;
		x1=Math.random()*lCanv;
		c=Math.round(Math.random()*50)+50;
		opa=Math.round(Math.random()*6)/10+0.3;
		c2=Math.round(c*0.85);
		coul="rgba("+c+","+c+","+c2+","+opa+")";
		ctFond.fillStyle=coul;
		ctFond.fillRect (x1,y1,0.9,4);
	}
	
	for (var i=0;i<d;i++)
	{
		ctFond.beginPath();
		c=200-Math.round(Math.random()*50);
		c2=Math.round(c*0.85);
		opa=Math.round(Math.random()*8)/10;
		coul="rgba("+c+","+c+","+c2+","+opa+")";
		r=Math.pow(Math.random()*5,2);
		y1=Math.random()*hCanv;
		x1=Math.random()*lCanv;
		ctFond.save();
		ctFond.translate(x1,y1);
		ctFond.rotate (angle);
		ctFond.scale (0.3,1);
		angle=(Math.random()-0.5)/2;
		ctFond.fillStyle=coul;
		ctFond.beginPath();
		ctFond.arc(0,0,r,0,Math.PI*2);
		ctFond.fill();
		c3=Math.round(Math.random()*50);
		c2=Math.round(c3*0.85);
		coul="rgba("+c3+","+c3+","+c2+","+opa/2+")";
		ctFond.fillStyle=coul;
		ctFond.scale (2,1);
		ctFond.beginPath(); // tache noire
		ctFond.arc(0,r*0.7,r*0.2,0,Math.PI*2);
		ctFond.fill();
		c4=Math.round(250-Math.random()*20);
		c2=Math.round(c4*0.85);
		coul="rgba("+c4+","+c4+","+c2+","+opa/4+")";
		ctFond.fillStyle=coul;
		ctFond.beginPath(); // tache blanche
		ctFond.arc(0,-r*0.25,r*0.3,0,Math.PI*2);
		ctFond.fill();
		ctFond.restore();
	}
	
}

function fondNoir()
{
	effaceFond();
	ctFond.fillStyle="black";
	ctFond.fillRect (0,0,lCanv,hCanv);
	var coul=0;
	var x1=0;
	var x2=0;
	var r=0;
	var opa=0;
	var angle=0;
	var d=lCanv;
	for (var i=0;i<d;i++)
	{
		ctFond.beginPath();
		c=Math.round(Math.random()*100);
		coul="rgba("+c+","+c+","+c+",0.5)";
		y1=Math.random()*hCanv;
		y2=Math.random()*hCanv;
		ctFond.lineWidth=Math.random()*10;
		ctFond.strokeStyle=coul;
		ctFond.moveTo(0,y1);
		ctFond.lineTo(lCanv,y2);
		ctFond.stroke();
	}
	
	for (var i=0;i<d;i++)
	{
		ctFond.beginPath();
		c=Math.round(Math.random()*180)-50;
		if (c<0) {c=0;}
		coul="rgba("+c+","+c+","+c+",0.2)";
		x0=Math.random()*lCanv;
		x1=x0+Math.random()*100-50;
		x2=x0+Math.random()*100-50;
		ctFond.lineWidth=Math.random()*50;
		ctFond.strokeStyle=coul;
		ctFond.moveTo(x1,0);
		ctFond.lineTo(x2,hCanv);
		ctFond.stroke();
	}
	
	for (var i=0;i<d;i++)
	{
		ctFond.beginPath();
		c=Math.round(Math.random()*50);
		opa=Math.round(Math.random()*4)/10+0.4;
		coul="rgba("+c+","+c+","+c+","+opa+")";
		r=Math.pow(Math.random()*5,2);
		y1=Math.random()*hCanv;
		x1=Math.random()*lCanv;
		ctFond.save();
		ctFond.translate(x1,y1);
		ctFond.rotate (angle);
		ctFond.scale (0.2,1);
		angle=(Math.random()-0.5)/2;
		ctFond.fillStyle=coul;
		ctFond.beginPath();
		ctFond.arc(0,0,r,0,Math.PI*2);
		ctFond.fill();
		c=Math.round(c+5);
		coul="rgba("+c+","+c+","+c+","+opa+")";
		ctFond.fillStyle=coul;
		ctFond.beginPath();
		ctFond.arc(0,r/2,r*0.7,0,Math.PI*2);
		ctFond.fill();
		ctFond.restore();
	}
}

function creeFond ()
{
	if (fond==1)
	{fondNoir();}	else	{fondBlanc();}
}

function fondPapier()
{
	effaceFond();
	ctFond.fillStyle = ctFond.createPattern(tImg[0], "repeat");
    ctFond.fillRect(0, 0, lCanv,hCanv);
}
