﻿function graphiques()
{
	etape="graphiques";
	
	effaceFond();
	
	var tabCoulCourbe=new Array();
	tabCoulCourbe[1]="red";
	tabCoulCourbe[2]="green";
	tabCoulCourbe[3]="orange";
	tabCoulCourbe[4]="blue";
	
	var hbandeau=Math.round(hCanv/25);	
	ctScore.font = "bold "+Math.round(hbandeau*0.7)+"px "+mFont;
	var hcanvas2=hCanv-hbandeau*2;
	ctScore.fillStyle="rgba(0,0,0,0.5)";
	ctScore.clearRect(0,0,lCanv,hCanv);
	ctScore.fillRect(0,0,lCanv,hbandeau);
	ctScore.fillRect(0,hCanv-hbandeau,lCanv,hbandeau);
	
	//titre
	
	ctScore.textAlign="center";
	ctScore.fillStyle="white";
	ctScore.fillText ("Evolution des fréquences phénotypiques et alléliques des phalènes",lCanv/2,hbandeau*0.75);
	
	//texte bas
	ctScore.font = "italic "+Math.round(hbandeau*0.7)+"px "+mFont;
	ctScore.textAlign="center";
	ctScore.fillStyle="white";
	ctScore.fillText ("Cliquer sur le graphique pour retourner au bilan",lCanv/2,hCanv-hbandeau*0.3);
	
	ctScore.strokeStyle="black";
	ctScore.lineWidth=0.5;
	ctScore.beginPath();
	ctScore.moveTo(lCanv/3,hbandeau);
	ctScore.lineTo(lCanv/3,hcanvas2+hbandeau);
	ctScore.stroke();
	
	//graphique
	ctScore.save();
	ctScore.translate(Math.round(lCanv/3),hbandeau);
		
	var haut=hcanvas2;
	var large=lCanv*2/3;

	ht=Math.round(haut*0.03);
	ctScore.font = "bold "+ht+"px "+mFont;
	
	ctScore.fillStyle= "black";
	ctScore.textAlign="left";
	
	ctScore.fillText ("GRAPHIQUE",ht,ht*1.5);
	
	var xgr0=Math.round(large/10)+0.5;
	var xgrMax=Math.round(large-ht*5)+0.5;
	var ygr0=Math.round(haut-ht*2)+0.5;
	var ygrMax=Math.round(ht*4)+0.5;
	var tFl=Math.round(ht/2);
	var tGr=Math.round(tFl/2);
	var xgrMax2=xgrMax-Math.round(tFl*2);
	var ygrMax2=ygrMax+Math.round(tFl*2);
	var lgr=xgrMax2-xgr0;
	var hgr=-(ygrMax2-ygr0);
	
	// tracé des axes
	ctScore.strokeStyle="black";
	ctScore.lineWidth=0.5;
	ctScore.beginPath();
	ctScore.moveTo(xgr0,ygr0);
	ctScore.lineTo(xgrMax,ygr0);
	ctScore.lineTo(xgrMax-tFl,ygr0-tFl);
	ctScore.moveTo(xgrMax,ygr0);
	ctScore.lineTo(xgrMax-tFl,ygr0+tFl);
	ctScore.stroke();
	
	ctScore.beginPath();
	ctScore.moveTo(xgr0,ygr0);
	ctScore.lineTo(xgr0,ygrMax);
	ctScore.lineTo(xgr0-tFl,ygrMax+tFl);
	ctScore.moveTo(xgr0,ygrMax);
	ctScore.lineTo(xgr0+tFl,ygrMax+tFl);
	ctScore.stroke();
	
	var tabCourbe=new Array;
	tabCourbe[1]=tFreq;
	tabCourbe[2]=new Array;
	for (var i=0;i<=annee;i++) {tabCourbe[2][i]=(100-tabCourbe[1][i]);}
	tabCourbe[3]=tFreqA;
	tabCourbe[4]=new Array;
	for (var i=0;i<=annee;i++) {tabCourbe[4][i]=(100-tabCourbe[3][i]);}
		
	// tracé des graduations
	htgr=Math.round(haut*0.02);
	ctScore.font = htgr+"px sans-serif";
	ctScore.textAlign="center";
	
	// abscisses
	for (var i=0;i<=annee;i++)
	{
		var xgr=Math.round(i/annee*lgr)+xgr0+0.5;
		ctScore.strokeStyle="rgb(230,230,230)";
		ctScore.beginPath();
		ctScore.moveTo(xgr,ygr0);
		ctScore.lineTo(xgr,ygr0+tGr);
		ctScore.stroke();
		ctScore.beginPath();
		ctScore.moveTo(xgr,ygr0);
		ctScore.lineTo(xgr,ygrMax);
		ctScore.stroke();
		if ((annee<20)||((i%2)==0))
		{
			ctScore.fillText (i,xgr,ygr0+htgr*1.5);
		}
	}
	
	
	// ordonnées
	ctScore.textAlign="right";
	
	for (var i=0;i<=10;i++)
	{ 
		var ygr=ygr0-hgr*(i*10/100);
		ctScore.strokeStyle="rgb(200,200,200)";
		ctScore.beginPath();
		ctScore.moveTo(xgr0,ygr);
		ctScore.lineTo(xgrMax,ygr);
		ctScore.stroke();
		ctScore.strokeStyle="black";
		ctScore.beginPath();
		ctScore.moveTo(xgr0,ygr);
		ctScore.lineTo(xgr0+tGr,ygr);
		ctScore.stroke();

		if ((i%2)==0) {ctScore.fillText (i*10,xgr0-htgr*0.5,ygr+htgr*0.25);}
			
	}
	
	// titres axes
	ctScore.textAlign="center";
	ctScore.fillText ("Fréquence (en %)",xgr0,ygrMax-htgr);
	ctScore.textAlign="left";
	ctScore.fillText ("Année",xgrMax+htgr*0.5,ygr0+htgr*0.25);
	
	// tracé du fond d'écorce
	ctScore.fillStyle="rgba(0,0,0,0.1)";
	for (var i=1;i<=annee;i++)
	{
		var xgr=Math.round(i/annee*lgr)+xgr0+0.5;
		var ygr=ygr0-hgr;

		if (tEcorce[i]>0) 
		{
			ctScore.fillRect(xgr-lgr/annee,ygr,lgr/annee,hgr);
		}
	}	
		

	
	// tracé de la courbe
	ctScore.lineWidth=1;
	for (c=1;c<5;c++)
	{
		if (tabCoche[c]>0)
		{
			ctScore.strokeStyle=tabCoulCourbe[c];
			ctScore.beginPath();
			for (var i=0;i<=annee;i++)
			{
				var xgr=Math.round(i/annee*lgr)+xgr0+0.5;
				var ygr=ygr0-hgr*(tabCourbe[c][i]/100);

				if (i==0) 
				{
					ctScore.moveTo(xgr,ygr);
				}
				else
				{
					ctScore.lineTo(xgr,ygr);
				}
			}	
			ctScore.stroke();
		}
	}
	
	
	ctScore.restore();
	
	//légende
	ctScore.save();
	ctScore.translate(0,hbandeau);
		
	var large=lCanv*2/3;

	var ht=Math.round(haut*0.03);
	var hCaseLeg=Math.round(ht*0.8);
	
	ctScore.font = "bold "+ht+"px "+mFont;
	ctScore.fillStyle= "black";
	ctScore.textAlign="left";
	
	ctScore.fillText ("LEGENDE",ht,ht*1.5);
	
	tLeg1=haut*2/8+ht*0.4;
	tLeg2=haut*3/8+ht*0.4;
	tLeg3=haut*4/8+ht*0.4;
	tLeg4=haut*5/8+ht*0.4;
	tLeg5=haut*6/8+ht*0.4;
	
	var ht=Math.round(lCanv*0.015);
	ctScore.font = ht+"px "+mFont;
	
	var decLeg=ht*2+hCaseLeg;
	ctScore.fillStyle= tabCoulCourbe[1];
	ctScore.fillText ("Pourcentage de phalènes [blancs]",decLeg,tLeg1);
	ctScore.fillStyle= tabCoulCourbe[2];
	ctScore.fillText ("Pourcentage de phalènes [noirs]",decLeg,tLeg2);
	ctScore.fillStyle= tabCoulCourbe[3];
	ctScore.fillText ("Fréquence de l'allèle c",decLeg,tLeg3);
	ctScore.fillStyle= tabCoulCourbe[4];
	ctScore.fillText ("Fréquence de l'allèle C+",decLeg,tLeg4);
	
	// cases
	ctScore.fillStyle= "black";
	ctScore.lineWidth=1;
	for (var i=2;i<6;i++)
	{
		ctScore.beginPath();
		ctScore.rect (Math.round(ht*1.5)+0.5,Math.round(haut*i/8-hCaseLeg/2)+0.5,hCaseLeg,hCaseLeg);	
		if (tabCoche[(i-1)]>0) {ctScore.fillRect (Math.round(ht*1.5)+3.5,Math.round(i*haut/8-hCaseLeg/2)+3.5,hCaseLeg-6,hCaseLeg-6);}
		ctScore.stroke();
	}
	
	ctScore.restore();
	
}