﻿function brassage ()
{
	var p=(sGcc*2+sGCc)/200;
	var q=(1-p);
	if (derive==1)
	{
		// brassage avec dérive
		var a1="";
		var a2="";
		console.log ("p="+p+" q="+q);
		for (var i=0;i<nTotPapi;i++)
			{
				tPapi[i].x=Math.random()*lCanv;
				tPapi[i].y=Math.random()*hCanv;
				tPapi[i].r=Math.random()*Math.PI*2;
				tPapi[i].ar=Math.random()*0.05-0.1;
				tPapi[i].vit=Math.random()*vitesse;
				tPapi[i].v=1;
				tPapi[i].o=Math.random()*2*Math.PI;
				if (Math.random()<p) {a1=0;} else {a1=1;}
				if (Math.random()<p) {a2=0;} else {a2=1;}
				if ((a1+a2)==0) // cc blanc
				{
					tPapi[i].g="cc";
				}
				if ((a1+a2)==2) // CC noir
				{
					tPapi[i].g="CC";
				}		
				if ((a1+a2)==1) // Cc noir
				{
					tPapi[i].g="Cc";
				}				
			}
	}
	else
	{
		// brassage sans dérive
		var pp=p*p;
		var pq=2*p*q;
		var qq=q*q;
		var geno,i,j;
		
		// par défaut CC
		for (i=0;i<nTotPapi;i++)
		{
			tPapi[i]=new Object();
			tPapi[i].x=Math.random()*lCanv;
			tPapi[i].y=Math.random()*hCanv;
			tPapi[i].r=Math.random()*Math.PI*2;
			tPapi[i].ar=Math.random()*0.05-0.1;
			tPapi[i].vit=Math.random()*vitesse;
			tPapi[i].v=1;
			tPapi[i].o=Math.random()*2*Math.PI;
			tPapi[i].g="CC";
		}
		
		// les cc (blancs)
		var ncc=Math.round(nTotPapi*pp);
		var nCC=Math.round(nTotPapi*qq);
		var nCc=nTotPapi-(ncc+nCC);
		for (var i=0;i<ncc;i++)
		{
			tPapi[i].g="cc"; // blancs
		}
		// les Cc (hétérozygotes)
		for (i=ncc;i<(nTotPapi-nCC);i++)
		{
			tPapi[i].g="Cc"; // noirs
		}			
		
		// on mélange
		shuffle (tPapi);
	}
	
	// mutations
	if (pMut>0)
	{
		for (i=0;i<nTotPapi;i++)
		{
			for (j=0;j<2;j++)
			{
				if (Math.random()<pMut)
				{
					geno=tPapi[i].g;
					//console.log ("mutation "+j+" "+geno[j]);
					if (geno[j]=="c")
					{
						var nouvAll="C";
					}
					else
					{
						var nouvAll="c";
					}
					if (j==0)
					{
						tPapi[i].g=nouvAll+geno[1];
					}
					else
					{
						tPapi[i].g=geno[0]+nouvAll;
					}					
				}
			}
		}
	}
	
	// phénotypes
	for (i=0;i<nTotPapi;i++)
	{
		if (tPapi[i].g=="cc")
		{
			tPapi[i].c=0; // blancs
		}
		else
		{
			tPapi[i].c=1; // noirs		
		}
	}
	
	
	tFreq[annee]=calcFreq();
	tGcc[annee]=calcGeno("cc");
	tGCC[annee]=calcGeno("CC");
	tGCc[annee]=100-(tGcc[annee]+tGCC[annee]);
	tFreqA[annee]=(tGcc[annee]*2+tGCc[annee])/2;
}

function calcFreq ()
{
	var nC=0;
	var nT=0;
	for (var i=0;i<nTotPapi;i++)
	{
		if (tPapi[i].v==1)
		{
			nT++;
			if (tPapi[i].c==0) {nC++;}
		}
	}
	console.log ("nC="+nC+" nT="+nT);
	return nC/nT*100;
}

function compteVivants () {
	var nT=0;
	for (var i=0;i<nTotPapi;i++)
	{
		if (tPapi[i].v==1)
		{
			nT++;
		}

	}
	return nT;
}

function compteGeno (geno) {
	var nG=0;
	var nT=0;
	for (var i=0;i<nTotPapi;i++)
	{
		if (tPapi[i].v==1)
		{
			nT++;
			if (tPapi[i].g==geno) {nG++;}
		}

	}
	return nG;
}

function calcGeno (geno)
{
	var nG=0;
	var nT=0;
	for (var i=0;i<nTotPapi;i++)
	{
		if (tPapi[i].v==1)
		{
			nT++;
			if (tPapi[i].g==geno) {nG++;}
		}

	}
	return nG/nT*100;
}

function shuffle(a)
{
   var j = 0;
   var valI = '';
   var valJ = valI;
   var l = a.length - 1;
   while(l > -1)
   {
		j = Math.floor(Math.random() * l);
		valI = a[l];
		valJ = a[j];
		a[l] = valJ;
		a[j] = valI;
		l = l - 1;
	}
	return a;
 }

function creePapiInit ()
{
	var p=pInit; // fréquence de l'allèle c blanc
	var q=(1-pInit);
	var pp=p*p;
	var pq=2*p*q;
	var qq=q*q;
	
	// par défaut CC
	for (var i=0;i<nTotPapi;i++)
	{
		tPapi[i]=new Object();
		tPapi[i].x=Math.random()*lCanv;
		tPapi[i].y=Math.random()*hCanv;
		tPapi[i].r=Math.random()*Math.PI*2;
		tPapi[i].ar=Math.random()*0.05-0.1;
		tPapi[i].vit=Math.random()*vitesse;
		tPapi[i].v=1;
		tPapi[i].o=Math.random()*2*Math.PI;
		tPapi[i].c=1;
		tPapi[i].g="CC";
	}
	
	// les cc (blancs)
	var ncc=Math.round(nTotPapi*pp);
	var nCC=Math.round(nTotPapi*qq);
	var nCc=nTotPapi-(ncc+nCC);
	for (var i=0;i<ncc;i++)
	{
		tPapi[i].c=0; // blancs
		tPapi[i].g="cc";
	}
	// les Cc (hétérozygotes)
	for (var i=ncc;i<(nTotPapi-nCC);i++)
	{
		tPapi[i].c=1; // noirs
		tPapi[i].g="Cc";
	}			
	
	// on mélange
	shuffle (tPapi);
	
	tFreq[0]=calcFreq();
	tGcc[0]=calcGeno("cc");
	tGCC[0]=calcGeno("CC");
	tGCc[0]=100-(tGcc[0]+tGCC[0]);
	tFreqA[0]=(tGcc[0]*2+tGCc[0])/2;
}


function testCase (x,y,actif)
{
	//case cochée ?
	var hbandeau=Math.round(hCanv/25);	
	var hcanvas2=hCanv-hbandeau*2;
	var haut=hcanvas2;
	var ht=Math.round(lCanv*0.015);
	var hCaseLeg=Math.round(ht*0.8);
	var deborde=hCaseLeg/3;	// on dépasse d'1/3 de case
	var coche=0;

	if ((x>(ht*1.5-deborde))&&(x<(ht*1.5+hCaseLeg+deborde)))
	{
		for (var i=2;i<6;i++)
		{
			var yCL1=haut*i/8-hCaseLeg/2+hbandeau;
			yCL1-=deborde;
			var yCL2=yCL1+hCaseLeg;
			yCL2+=deborde;
			if ((y>yCL1)&&(y<yCL2))
			{
				coche=i-1;
			}
		}
	}
	
	if (actif)
	{
		tabCoche[coche]=Math.round(1-tabCoche[coche]);
		if ((coche>0)&&(coche<5)) {graphiques();}
		return false;
	}
	else
	{
		return coche;
	}
}
